"use strict";

var _checkStatus = _interopRequireDefault(require("../util/checkStatus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

module.exports = function getRetryInterceptor(fetch, request, option) {
  //retry count
  var retryCount = option.retryCount; //timeout

  var retryTimeout = option.retryTimeout;

  var retry = function retry() {
    return fetch(request).then(_checkStatus.default).catch(function (error) {
      return onRejected(error);
    });
  };

  var retryAdapter = function retryAdapter() {
    if (retryTimeout && retryTimeout > 0) {
      return (
        /*#__PURE__*/
        _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee() {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return timeout(retryTimeout);

                case 2:
                  return _context.abrupt("return", retry());

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }))
      );
    } else {
      return retry;
    }
  }; //get retry function


  var retryFunction = retryAdapter();

  var onFulfilled = function onFulfilled(result) {
    return result;
  };

  var onRejected =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(error) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(retryCount >= 1)) {
                _context2.next = 5;
                break;
              }

              retryCount--;
              return _context2.abrupt("return", retryFunction());

            case 5:
              return _context2.abrupt("return", Promise.reject(error));

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function onRejected(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return [onFulfilled, onRejected];
};

function timeout(timeout) {
  return new Promise(function (resolve) {
    setTimeout(resolve, timeout);
  });
}