"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDate = isDate;
exports.isArray = isArray;
exports.isObject = isObject;
exports.isFunction = isFunction;
exports.isNormalObject = isNormalObject;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var toString = Object.prototype.toString;
/**
 * 对象是否为date类型
 */

function isDate(val) {
  return toString.call(val) === '[object Date]';
}
/**
 * 对象是否为array类型
 */


function isArray(val) {
  return toString.call(val) === '[object Array]';
}
/**
 * 对象是否为对象类型
 */


function isObject(val) {
  return val !== null && _typeof(val) === 'object';
}
/**
 * 对象是否为函数类型
 */


function isFunction(val) {
  return toString.call(val) === '[object Function]';
}
/**
 * 对象是否为普通对象类型
 */


function isNormalObject(val) {
  return toString.call(val) === '[object Object]';
}